#include "idlewatcher.h"
#include <KIdleTime>
#include <QDebug>
#include <QtDBus>

IdleWatcher::IdleWatcher(int secs, int  secs_t,QObject *parent):
    QObject(parent),
    mSecs(secs),mSecs_t(secs_t)
{
    connect(KIdleTime::instance(),
            &KIdleTime::resumingFromIdle,
            this,
            &IdleWatcher::onResumingFromIdle);
    connect(KIdleTime::instance(),
            static_cast<void (KIdleTime::*)(int, int)>(&KIdleTime::timeoutReached),
            this,
            &IdleWatcher::onTimeoutReached);

    connect(KIdleTime::instance(),
            &KIdleTime::resumingFromIdle,
            this,
            &IdleWatcher::onResumingFromIdle);
    connect(KIdleTime::instance(),
            static_cast<void (KIdleTime::*)(int, int)>(&KIdleTime::timeoutReached),
            this,
            &IdleWatcher::onTimeoutScreensaver);
    setup();
}

IdleWatcher::~IdleWatcher()
{
    KIdleTime::instance()->removeIdleTimeout(mIdentifier);
    KIdleTime::instance()->removeIdleTimeout(mIdentifier_t);
}

void IdleWatcher::reset(int secs)
{
    if(mSecs != 0){
       KIdleTime::instance()->removeIdleTimeout(mIdentifier);
    }
    mSecs = secs;
    setup();
}

void IdleWatcher::resetmTime(int secs_t)
{
    if(mSecs_t != 0){
        KIdleTime::instance()->removeIdleTimeout(mIdentifier_t);
    }
    mSecs_t = secs_t;
    setup();
}

void IdleWatcher::onResumingFromIdle()
{
    qDebug() << "Somethings happened";
}

void IdleWatcher::onTimeoutReached(int identifier, int timeout)
{
//    qWarning() << "all timeouts:" << KIdleTime::instance()->idleTimeouts();
    if(mIdentifier == identifier && timeout == mSecs * 1000) {
//        KIdleTime::instance()->removeIdleTimeout(mIdentifier);
        emit requestLock();
    }else {
        qWarning() <<"Timeout Reched,id:" << mIdentifier << identifier << "time:" << timeout << mSecs* 1000;
    }
}

void IdleWatcher::onTimeoutScreensaver(int identifier,int timeout)
{
    if(mIdentifier_t == identifier && timeout == mSecs_t * 1000) {
//        KIdleTime::instance()->removeIdleTimeout(mIdentifier);
        emit requestScreensaver();
    }else {
        qWarning() <<"Timeout Screensaver,id:" << mIdentifier_t << identifier << "time:" << timeout << mSecs_t* 1000;
    }
}


void IdleWatcher::removeIdleTimeout()
{
    KIdleTime::instance()->removeAllIdleTimeouts();
}
void IdleWatcher::setup()
{
//    qWarning() << "---------------------" << mIdentifier;
    if(mSecs != 0)
       mIdentifier = KIdleTime::instance()->addIdleTimeout(1000 * mSecs);
    if(mSecs_t != 0)
       mIdentifier_t = KIdleTime::instance()->addIdleTimeout(1000 * mSecs_t);
}
