#ifndef IDLEWATCHER_H
#define IDLEWATCHER_H

#include <QObject>

class IdleWatcher : public QObject
{
    Q_OBJECT
public:
    explicit IdleWatcher(int secs, int secs_t,QObject *parent = nullptr);
    virtual ~IdleWatcher();
public Q_SLOTS:
    void reset(int secs);
    void resetmTime(int secs_t);
    void removeIdleTimeout();
private Q_SLOTS:
    void onResumingFromIdle();
    void onTimeoutReached(int identifier, int timeout);
    void setup();
    void onTimeoutScreensaver(int identifier, int timeouts);

Q_SIGNALS:
    void requestLock();
    void requestScreensaver();

private:
    int mSecs;
    int mSecs_t;
    int mIdentifier { 0 };
    int mIdentifier_t { 0 };
};

#endif // IDLEWATCHER_H
