#include "lockscreenshortcut.h"
#include <nde-globalkeys.h>
#include <QDebug>

namespace NSS {
#define DEFAULT_SHORTCUT "Control+Alt+L"
#define DEFAULT_SHORTCUT_1 "Meta+L"
#define DEFAULT_SHORTCUT_2 "Control+Alt+KP_Delete"
#define DEFAULT_SHORTCUT_3 "Control+Alt+Delete"
LockScreenShortcut::LockScreenShortcut(QObject *parent) : QObject(parent)
{
    mLockShortcut = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter"), tr("Activate Lock Screen"), this);
    if (mLockShortcut)
    {
        connect(mLockShortcut, &GlobalKeyShortcut::Action::registrationFinished, this, [=]{
            if (mLockShortcut->shortcut().isEmpty())
            {
                mLockShortcut->changeShortcut(DEFAULT_SHORTCUT);
            }
        });
        connect(mLockShortcut, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }

    mLockShortcut1 = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter1"), tr("Activate Lock Screen"), this);
    if(mLockShortcut1)
    {
        connect(mLockShortcut1, &GlobalKeyShortcut::Action::registrationFinished, [this] {
            if(mLockShortcut1->shortcut().isEmpty())
                mLockShortcut1->changeShortcut(DEFAULT_SHORTCUT_1);
        });
        connect(mLockShortcut1, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }

    mLockShortcut2 = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter2"), tr("Activate Lock Screen"), this);
    if(mLockShortcut2)
    {
        connect(mLockShortcut2, &GlobalKeyShortcut::Action::registrationFinished, [this] {
            if(mLockShortcut2->shortcut().isEmpty())
                mLockShortcut2->changeShortcut(DEFAULT_SHORTCUT_2);
        });
        connect(mLockShortcut2, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }

    mLockShortcut3 = GlobalKeyShortcut::Client::instance()->addAction(
                QString(), QString("/nde/screensaver/greeter3"), tr("Activate Lock Screen"), this);
    if(mLockShortcut3)
    {
        connect(mLockShortcut3, &GlobalKeyShortcut::Action::registrationFinished, [this] {
            if(mLockShortcut3->shortcut().isEmpty())
                mLockShortcut3->changeShortcut(DEFAULT_SHORTCUT_3);
        });
        connect(mLockShortcut3, SIGNAL(activated()), this, SIGNAL(globalKeyActivated()));
    }
}
}
